﻿#define _CRTDBG_MAP_ALLOC 

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <mmsystem.h>
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <assert.h>
#include <tchar.h>
#include <shlwapi.h>
#include <windowsx.h>
#include <time.h>
#include <locale.h>
#include <stdlib.h>
#include <crtdbg.h>  
#include <Digitalv.h>


#pragma comment( lib, "shlwapi.lib" )
#pragma comment(lib,"msvfw32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib, "comctl32.lib")


#define TEMP_FILE_NAME                     L"soundfile.mp3"
#define LOG_FILE_NAME                      L"soundplayer.log"                            

#define TEXT_BUTTON_PAUSE                  L"▮▮"                
#define TEXT_BUTTON_PLAY                   L"▶"


typedef struct tagID3V2HEADER
{
	char        tag[3];
	char        version[2];
	char        flags;
	char       size[4]; //syncface
} ID3V2HEADER;

typedef struct _tagThread
{
	HANDLE hThread;
	DWORD dwThreadId;
}Thread;

typedef struct _tagButtonControll
{
	HWND     hButton;              //ボタン
	WNDPROC  DefaultProc;          //もともと
	WNDPROC  NewProc;              //新しい
	HICON    hIcon;                //表示する画像
}BC;

typedef struct _tagTrackbarControll
{
	HWND    hTrackbar;             //トラックバー
	Thread  th;                    //固有のスレッド
	DWORD   Status;                //処理していくうえで必要な情報
	
}TC;

typedef struct tagInternalData
{
	//現在再生しているデータに関するもの
	DWORD maxSrc;                 //曲の長さ[src]
	MCI_OPEN_PARMS open;
	MCI_PLAY_PARMS play;
	Thread th;               //ウィンドウのあたり判定を行うthread


	DWORD Valume;                 //音量

	int NowPlay;         //現在再生してるファイルのアドレス
	int MaxPlay;         //減殺再生しているファイル軍の総数

	WCHAR *ParentDir;    //親ディレクトリ
	WCHAR **File;        //これから再生するファイル名

	//トラックバーコントロール
	TC hTrack_Play;                     //再生/停止
	TC hTrack_Sound;                    //音量設定
	//ボタンコントロール
	BC hButton_Play;                    //再生/停止
	BC hButton_Sound;                   //音量設定

}InternalData;


#define OPTP(p)                           #p


//hTrack_Playのステータス一覧
//
//     |0|A|B|C|D|E|....
//bit  |1|2|3|4|5|6|....
//
//0...この曲は再生可能か
//A...曲に関するデータがあるかどうか
//B...曲の再生が終わったかどうか
//C...コリジョン(ユーザーがWindow内に侵入しているか)
//D...つまみをユーザーがつかんでいるかどうか(D==TRUE ならば C==TRUE となるはず...)
//E...MCIが現在処理している
//F...現在再生は停止している
#define SOUND_STATUS_ENABLE_PLAY          (0x00001)                 //(0)
#define SOUND_STATUS_DATA_EXSIST          (0x00002)                 //(A)
#define SOUND_STATUS_PLAY_ENDED           (0x00004)                 //(B)
#define SOUND_STATUS_CUR_COLLISON         (0x00008)                 //(C)
#define SOUND_STATUS_THUMB_USER_UPDATE    (0x00010)                 //(D)
#define SOUND_STATUS_WAIT_MCI             (0x00020)                 //(E)
#define SOUND_STATUS_PLAY_PAUSED          (0x00040)                 //(F)


//hTrack_Sound
#define SOUND_WINDOW_STATUS_HIDE          (0)                       //表示していない
#define SOUND_WINDOW_STATUS_SHOW          (1)                       //表示している
#define SOUND_WINDOW_STATUS_NO_COLLISION  (2)                       //ウィンドウを表示しているがマウスカーソルはあっさてな方向にある


#define SWITCH(p)                         rp=(VOID*)p;              //定数型の指揮と同等に扱えるように
#define CASE(p)                           if(rp==p)


#define TIMER_ID_PLAY                     (1)                       //タイマー(再生に関するトラックバー)
#define TIMER_ID_SOUND                    (2)                       //タイマー(音量に関するトラックバー)
#define TIMER_ID_FADEAWAY                 (3)                       //タイマー(音量に関するトラックバーを時間で消去する)

//ウィンドウ
#define NO_WINDOW                         (0)                       //現在のウィンドウの位置にカーソルはない
#define MAIN_WINDOW                       (1)                       //メインウィンドウの位置
#define PLAY_WINDOW                       (2)                       //トラックバーの位置
#define SOUND_WINDOW                      (3)                       //

//
//MCIを使い、サウンドファイルを読み込む
//lpFilePath...読み込ませたいファイル名
//lpstrDeviceType...そのファイルのタイプ(今のところはmp3のみを考える)
//rettemp...作成された構造体の情報
//callflag...読み込み失敗時に、create_temp_fileを呼び出すかどうか
//
//return TRUE...成功 / FALSE...失敗
//
int InitSoundStruct(LPCWSTR lpFilePath, LPCWSTR lpstrDeviceType, InternalData *retTemp, int callflag = TRUE);

//
//ID3タグがあるとき、それがない状態のmp3を作成する
//lpFilePath...ID3タグがあるかもしれないファイルパス
//lpstrDeviceType...そのファイルのタイプ(今のところはmp3のみを考える)
//rettemp...作成された構造体の情報
//
//return TRUE...成功 / FALSE...失敗
//
int create_temp_file(LPCWSTR lpFilePath, LPCWSTR lpstrDeviceType, InternalData *retTemp);

//
//トラックバーの作成
//hWnd...メインウィンドウのハンドル
//
//return 成功時TRUE / 失敗時FALSE
//
BOOL CreateTrackbar(HWND hWnd, InternalData *temp);

//
//トラックバーに関する設定を行う
//indata...設定されるべきトラックバーのハンドル
//
#define UpdateTrackbarStatus(hwnd, _max) SendMessageW((HWND)(hwnd), TBM_SETRANGE, (WPARAM)TRUE, (LPARAM)MAKELPARAM(0, _max))

//
//ウィンドウのカスタムドローを一括して行う
//hWnd...メインウィンドウのハンドル
//indata...アプリが一括して管理するデータの構造体
//wp,lp...ウィンドウプロシージャから受け取った値
//
//return 様々な値
//
LRESULT CustomDrawProc(HWND hWnd, InternalData indata, WPARAM wp, LPARAM lp);

//
//音声を再生する
//indata...変更されるべきデータを持った構造体
//
//return 常にTRUE
//
int StartPlaySound(InternalData *indata);

//
//OutputDebugStringの改造版
//(lpOutputString,...)...出力される文字列
//
//return 成功...TRUE / 失敗...FALSE
//
int OutputDebugStringEx(LPCWSTR lpOutputString, ...);
int OutputDebugStringExA(LPCSTR lpOutputString, ...);

//
//Userに開かれるべきファイルを訪ねる
//hWnd...親ウィンドのハンドル
//temp...情報を受け取ることができる構造体
//
//return TRUE...成功 /FALSE...失敗
//
int GetFileNames(HWND hWnd, InternalData *temp);

//
//作成されたファイルパスデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData_indata(InternalData *indata);

//
//作成されたMCIデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData_MCI(InternalData *indata);

//
//作成されたファイルパス、MCIデータといったデータをすべて削除する
//indata...削除されるべきデータを持った構造体
//
//return ... 常にTRUE
//
int DeleteInternalData(InternalData *indata);

//
//作成したtempを削除
//
void deletetemp(void);

//
//ボタンを作成
//hWnd...メインウィンドウのハンドル
//
//return 作成されたボタンのハンドル / 失敗時：NULL
//
int CreateButton(HWND hWnd, InternalData *temp);

//
//Logを出力する
//(lpOutputString,...)...出力される文字列
//
//return 成功...TRUE / 失敗...FALSE
//
int OutputExeLog(LPCWSTR lpOutputString, ...);

//
//Logを出力する
//(lpOutputString,...)...出力される文字列(CHAR)
//先にOutputExeLogを呼び出しておくこと!
//(OPTPマクロが使えないUNICODEだと)
//
//return 成功...TRUE / 失敗...FALSE
//
#ifdef _DEBUG 
int _OutputExeLogA(LPCSTR lpOutputString, ...);

#define OutputExeLogA(str,...) _OutputExeLogA("{[%s at %s(%d)]}" str,PathFindFileNameA(__FILE__),__func__,__LINE__, __VA_ARGS__)

#else
#define OutputExeLogA(str,...) (str)
#endif

//
//ボタンに画像を張り付けるためのプロシージャ
//
//引数...WindowProcと同じ
//return ... 同じ
//
LRESULT CustomDefButtonProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);

//
//ボタンコントロールの値を保持する
//
//button ...　保存したいボタンの情報
//hWnd...得たい情報のhwnd(登録するときは必ずNULL)
//*bc...得たい情報
//DeleteFlag ... 削除するかどうか
//
//return ... 成功時/TRUE 失敗時/FALSE
//
int RegisterButtonInfo(BC button, HWND hWnd, BC *bc, int DeleteFlag);

//
//音量を設定する
//
//SoundVolume...サウンドの大きさ
//reDraw...設定した音量にトラックバーを設定するかどうか
//
BOOL SetSound(InternalData *indata, DWORD SoundVolume, BOOL reDraw = TRUE);

//
//ウィンドウのあたり判定に関するスレッドを作成
//
int Thread_StartCollision(InternalData *indata);

//
//バージョン情報の表示
//
VOID ShowVersionInfo(HWND hwnd);

/////////////////////////////////////////////////////////////////////
//
//ウィンドウプロシージャが見にくいので、量が多いもの.これから増えるであろう物は分離
//
////////////////////////////////////////////////////////////////////


//
//WM_TIMERを処理する
//
LRESULT TimerEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp);

//
//WM_COMMAND
//
LRESULT CmdEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp);

//
//WM_HSCROLL
//
LRESULT HScrollEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp);

//
//WM_VSCROLL
//
LRESULT VScrollEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp);

//
//WM_MCINOTIFY
//
LRESULT MCINotifyEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp);


#if _DEBUG
#define IF(x)                             OutputExeLogA("if(%s) は \'%s\' として評価されました。\n",OPTP(x),(x)==1 ? "true" : "false"); if(x)
#else
#define IF(x)                             if(x)
#endif

